/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	"context"
	"time"

	v1 "github.com/kyverno/kyverno/api/reports/v1"
	scheme "github.com/kyverno/kyverno/pkg/client/clientset/versioned/scheme"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// ClusterEphemeralReportsGetter has a method to return a ClusterEphemeralReportInterface.
// A group's client should implement this interface.
type ClusterEphemeralReportsGetter interface {
	ClusterEphemeralReports() ClusterEphemeralReportInterface
}

// ClusterEphemeralReportInterface has methods to work with ClusterEphemeralReport resources.
type ClusterEphemeralReportInterface interface {
	Create(ctx context.Context, clusterEphemeralReport *v1.ClusterEphemeralReport, opts metav1.CreateOptions) (*v1.ClusterEphemeralReport, error)
	Update(ctx context.Context, clusterEphemeralReport *v1.ClusterEphemeralReport, opts metav1.UpdateOptions) (*v1.ClusterEphemeralReport, error)
	Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error
	Get(ctx context.Context, name string, opts metav1.GetOptions) (*v1.ClusterEphemeralReport, error)
	List(ctx context.Context, opts metav1.ListOptions) (*v1.ClusterEphemeralReportList, error)
	Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.ClusterEphemeralReport, err error)
	ClusterEphemeralReportExpansion
}

// clusterEphemeralReports implements ClusterEphemeralReportInterface
type clusterEphemeralReports struct {
	client rest.Interface
}

// newClusterEphemeralReports returns a ClusterEphemeralReports
func newClusterEphemeralReports(c *ReportsV1Client) *clusterEphemeralReports {
	return &clusterEphemeralReports{
		client: c.RESTClient(),
	}
}

// Get takes name of the clusterEphemeralReport, and returns the corresponding clusterEphemeralReport object, and an error if there is any.
func (c *clusterEphemeralReports) Get(ctx context.Context, name string, options metav1.GetOptions) (result *v1.ClusterEphemeralReport, err error) {
	result = &v1.ClusterEphemeralReport{}
	err = c.client.Get().
		Resource("clusterephemeralreports").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of ClusterEphemeralReports that match those selectors.
func (c *clusterEphemeralReports) List(ctx context.Context, opts metav1.ListOptions) (result *v1.ClusterEphemeralReportList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1.ClusterEphemeralReportList{}
	err = c.client.Get().
		Resource("clusterephemeralreports").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested clusterEphemeralReports.
func (c *clusterEphemeralReports) Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Resource("clusterephemeralreports").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a clusterEphemeralReport and creates it.  Returns the server's representation of the clusterEphemeralReport, and an error, if there is any.
func (c *clusterEphemeralReports) Create(ctx context.Context, clusterEphemeralReport *v1.ClusterEphemeralReport, opts metav1.CreateOptions) (result *v1.ClusterEphemeralReport, err error) {
	result = &v1.ClusterEphemeralReport{}
	err = c.client.Post().
		Resource("clusterephemeralreports").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(clusterEphemeralReport).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a clusterEphemeralReport and updates it. Returns the server's representation of the clusterEphemeralReport, and an error, if there is any.
func (c *clusterEphemeralReports) Update(ctx context.Context, clusterEphemeralReport *v1.ClusterEphemeralReport, opts metav1.UpdateOptions) (result *v1.ClusterEphemeralReport, err error) {
	result = &v1.ClusterEphemeralReport{}
	err = c.client.Put().
		Resource("clusterephemeralreports").
		Name(clusterEphemeralReport.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(clusterEphemeralReport).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the clusterEphemeralReport and deletes it. Returns an error if one occurs.
func (c *clusterEphemeralReports) Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error {
	return c.client.Delete().
		Resource("clusterephemeralreports").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *clusterEphemeralReports) DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Resource("clusterephemeralreports").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched clusterEphemeralReport.
func (c *clusterEphemeralReports) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.ClusterEphemeralReport, err error) {
	result = &v1.ClusterEphemeralReport{}
	err = c.client.Patch(pt).
		Resource("clusterephemeralreports").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
